diff --git a/roms/ipxe/src/arch/i386/interface/vmware/vmware.c b/roms/ipxe/src/arch/i386/interface/vmware/vmware.c
new file mode 100644
index 0000000000000000000000000000000000000000..8074e6118f525c6c306ea0f5077198f3284d955f
--- /dev/null
+++ b/roms/ipxe/src/arch/i386/interface/vmware/vmware.c
@@ -0,0 +1,58 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * VMware backdoor mechanism
+ *
+ * Based on the unofficial documentation at
+ *
+ *   http://sites.google.com/site/chitchatvmback/backdoor
+ *
+ */
+
+#include <stdint.h>
+#include <errno.h>
+#include <ipxe/vmware.h>
+
+/**
+ * Detect VMware presence
+ *
+ * @ret rc		Return status code
+ */
+int vmware_present ( void ) {
+	uint32_t version;
+	uint32_t magic;
+	uint32_t product_type;
+
+	/* Perform backdoor call */
+	vmware_cmd_get_version ( &version, &magic, &product_type );
+
+	/* Check for VMware presence */
+	if ( magic != VMW_MAGIC ) {
+		DBGC ( VMW_MAGIC, "VMware not present\n" );
+		return -ENOENT;
+	}
+
+	DBGC ( VMW_MAGIC, "VMware product type %04x version %08x detected\n",
+	       product_type, version );
+	return 0;
+}
diff --git a/roms/ipxe/src/arch/i386/prefix/exeprefix.S b/roms/ipxe/src/arch/i386/prefix/exeprefix.S
index c7e57cee508787774b37de4c8209..cb61287d315b574103004e6f3749 100644
--- a/roms/ipxe/src/arch/i386/prefix/exeprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/exeprefix.S
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  *
  */
 
@@ -113,7 +114,7 @@ _exe_start:
 	call	alloc_basemem
 	xorl	%esi, %esi
 	movl	$EXE_DECOMPRESS_ADDRESS, %edi
-	clc
+	orl	$0xffffffff, %ebp	/* Allow arbitrary relocation */
 	call	install_prealloc
 
 	/* Set up real-mode stack */
diff --git a/roms/ipxe/src/arch/i386/prefix/kkkpxeprefix.S b/roms/ipxe/src/arch/i386/prefix/kkkpxeprefix.S
new file mode 100644
index 0000000000000000000000000000000000000000..27ed231e7d5a66ffabde887ce67a4f3bc9e4e205
--- /dev/null
+++ b/roms/ipxe/src/arch/i386/prefix/kkkpxeprefix.S
@@ -0,0 +1,19 @@
+/*****************************************************************************
+ * PXE prefix that keeps the whole PXE stack present and provides an exit hook
+ *
+ * This prefix is essentially intended solely for the case of ipxelinux.0
+ *****************************************************************************
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER )
+
+/* Since we have the whole stack, we can use cached DHCP information */
+REQUIRE_OBJECT ( pxeparent_dhcp )
+
+/* Provide the PXENV_FILE_EXIT_HOOK API call */
+REQUIRE_OBJECT ( pxe_exit_hook )
+
+#define PXELOADER_KEEP_UNDI
+#define PXELOADER_KEEP_PXE
+#define _pxe_start _kkkpxe_start
+#include "pxeprefix.S"
diff --git a/roms/ipxe/src/arch/i386/prefix/libprefix.S b/roms/ipxe/src/arch/i386/prefix/libprefix.S
index 77151a67e0bb75a63d468f29d0f9..197a86bc8e8a9b8215878a20c469 100644
--- a/roms/ipxe/src/arch/i386/prefix/libprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/libprefix.S
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  *
  */
 
@@ -49,7 +50,7 @@ FILE_LICENCE ( GPL2_OR_LATER )
 	.section ".prefix.data", "aw", @progbits
 progress_\@:
 	.asciz	"\message"
-	.size	progress_\@, . - progress\@
+	.size	progress_\@, . - progress_\@
 	.previous
 	.endm
 #endif
@@ -326,7 +327,6 @@ process_bytes:
 #ifndef KEEP_IT_REAL
 
 	/* Preserve registers */
-	pushfw
 	pushl	%eax
 	pushl	%ebp
 
@@ -397,7 +397,6 @@ process_bytes:
 	/* Restore registers and return */
 	popl	%ebp
 	popl	%eax
-	popfw
 	ret
 
 #else /* KEEP_IT_REAL */
@@ -546,8 +545,7 @@ alloc_basemem:
  * Free space allocated with alloc_basemem.
  *
  * Parameters:
- *   %ax : .text16 segment address
- *   %bx : .data16 segment address
+ *   none (.text16 segment address is implicit in %cs)
  * Returns:
  *   %ax : 0 if successfully freed
  * Corrupts:
@@ -560,14 +558,14 @@ alloc_basemem:
 free_basemem:
 	/* Preserve registers */
 	pushw	%fs
+	pushw	%ax
 
 	/* Check FBMS counter */
-	pushw	%ax
+	movw	%cs, %ax
 	shrw	$6, %ax
 	pushw	$0x40
 	popw	%fs
 	cmpw	%ax, %fs:0x13
-	popw	%ax
 	jne	1f
 
 	/* Check hooked interrupt count */
@@ -575,6 +573,7 @@ free_basemem:
 	jne	1f
 
 	/* OK to free memory */
+	movw	%cs, %ax
 	addw	$_text16_memsz_pgh, %ax
 	addw	$_data16_memsz_pgh, %ax
 	shrw	$6, %ax
@@ -582,6 +581,7 @@ free_basemem:
 	xorw	%ax, %ax
 
 1:	/* Restore registers and return */
+	popw	%ax
 	popw	%fs
 	ret
 	.size free_basemem, . - free_basemem
@@ -614,17 +614,19 @@ install:
 	/* Preserve registers */
 	pushl	%esi
 	pushl	%edi
+	pushl	%ebp
 	/* Allocate space for .text16 and .data16 */
 	call	alloc_basemem
 	/* Image source = %cs:0000 */
 	xorl	%esi, %esi
 	/* Image destination = default */
 	xorl	%edi, %edi
-	/* Allow relocation */
-	clc
+	/* Allow arbitrary relocation */
+	orl	$0xffffffff, %ebp
 	/* Install text and data segments */
 	call	install_prealloc
 	/* Restore registers and return */
+	popl	%ebp
 	popl	%edi
 	popl	%esi
 	ret
@@ -640,7 +642,9 @@ install:
  *   %bx  : .data16 segment address
  *   %esi : Image source physical address (or zero for %cs:0000)
  *   %edi : Decompression temporary area physical address (or zero for default)
- *   CF set : Avoid relocating to top of memory
+ *   %ebp : Maximum end address for relocation
+ *          - 0xffffffff for no maximum
+ *          - 0x00000000 to inhibit use of INT 15,e820 and INT 15,e801
  * Corrupts:
  *   none
  ****************************************************************************
@@ -655,27 +659,30 @@ install_prealloc:
 	pushw	%ds
 	pushw	%es
 	cld			/* Sanity: clear the direction flag asap */
-	pushfw
 
 	/* Set up %ds for (read-only) access to .prefix */
 	pushw	%cs
 	popw	%ds
 
-	/* Copy decompression temporary area physical address to %ebp */
-	movl	%edi, %ebp
+	/* Save decompression temporary area physical address */
+	pushl	%edi
 
-	/* Install .text16.early */
+	/* Install .text16.early and calculate %ecx as offset to next block */
 	progress "  .text16.early\n"
 	pushl	%esi
 	xorl	%esi, %esi
 	movw	%cs, %si
 	shll	$4, %esi
+	pushl	%esi			/* Save original %cs:0000 */
 	addl	$_text16_early_lma, %esi
 	movzwl	%ax, %edi
 	shll	$4, %edi
 	movl	$_text16_early_filesz, %ecx
 	movl	$_text16_early_memsz, %edx
 	call	install_block		/* .text16.early */
+	popl	%ecx			/* Calculate offset to next block */
+	subl	%esi, %ecx
+	negl	%ecx
 	popl	%esi
 
 #ifndef KEEP_IT_REAL
@@ -730,7 +737,7 @@ payload_death_message:
 	jnz	1f
 	movw	%cs, %si
 	shll	$4, %esi
-1:	addl	payload_lma, %esi
+1:	addl	%ecx, %esi
 
 	/* Install .text16.late and .data16 */
 	progress "  .text16.late\n"
@@ -747,6 +754,9 @@ payload_death_message:
 	/* Set up %ds for access to .data16 */
 	movw	%bx, %ds
 
+	/* Restore decompression temporary area physical address */
+	popl	%edi
+
 #ifdef KEEP_IT_REAL
 	/* Initialise libkir */
 	movw	%ax, (init_libkir_vector+2)
@@ -754,7 +764,7 @@ payload_death_message:
 #else
 	/* Find a suitable decompression temporary area, if none specified */
 	pushl	%eax
-	testl	%ebp, %ebp
+	testl	%edi, %edi
 	jnz	1f
 	/* Use INT 15,88 to find the highest available address via INT
 	 * 15,88.  This limits us to around 64MB, which should avoid
@@ -762,14 +772,14 @@ payload_death_message:
 	 */
 	movb	$0x88, %ah
 	int	$0x15
-	movw	%ax, %bp
-	addl	$0x400, %ebp
-	subl	$_textdata_memsz_kb, %ebp
-	shll	$10, %ebp
+	movw	%ax, %di
+	addl	$0x400, %edi
+	subl	$_textdata_memsz_kb, %edi
+	shll	$10, %edi
 	/* Sanity check: if we have ended up below 1MB, use 1MB */
-	cmpl	$0x100000, %ebp
+	cmpl	$0x100000, %edi
 	jae	1f
-	movl	$0x100000, %ebp
+	movl	$0x100000, %edi
 1:	popl	%eax
 
 	/* Install .text and .data to temporary area in high memory,
@@ -777,21 +787,23 @@ payload_death_message:
 	 * properly.
 	 */
 	progress "  .textdata\n"
-	movl	%ebp, %edi
+	pushl	%edi
 	movl	$_textdata_filesz, %ecx
 	movl	$_textdata_memsz, %edx
 	call	install_block
+	popl	%edi
 
 	/* Initialise librm at current location */
 	progress "  init_librm\n"
 	movw	%ax, (init_librm_vector+2)
-	movl	%ebp, %edi
 	lcall	*init_librm_vector
 
-	/* Skip relocation if CF was set on entry */
-	popfw
-	pushfw
-	jc	skip_relocate
+	/* Inhibit INT 15,e820 and INT 15,e801 if applicable */
+	testl	%ebp, %ebp
+	jnz	1f
+	incb	memmap_post
+	decl	%ebp
+1:
 
 	/* Call relocate() to determine target address for relocation.
 	 * relocate() will return with %esi, %edi and %ecx set up
@@ -815,7 +827,6 @@ payload_death_message:
 	/* Initialise librm at new location */
 	progress "  init_librm\n"
 	lcall	*init_librm_vector
-skip_relocate:
 #endif
 
 	/* Close access to payload */
@@ -824,7 +835,6 @@ skip_relocate:
 	lcall	*close_payload_vector
 
 	/* Restore registers */
-	popfw
 	popw	%es
 	popw	%ds
 	popal
@@ -855,17 +865,6 @@ close_payload_vector:
 	.word 0
 	.size close_payload_vector, . - close_payload_vector
 
-	/* Payload address */
-	.section ".prefix.lib", "awx", @progbits
-payload_lma:
-	.long 0
-	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
-	.ascii	"ADHL"
-	.long	payload_lma
-	.long	1
-	.long	0
-	.previous
-
 	/* Dummy routines to open and close payload */
 	.section ".text16.early.data", "aw", @progbits
 	.weak	open_payload
@@ -883,8 +882,7 @@ close_payload:
  * Uninstall all text and data segments.
  *
  * Parameters:
- *   %ax  : .text16 segment address
- *   %bx  : .data16 segment address
+ *   none (.text16 segment address is implicit in %cs)
  * Returns:
  *   none
  * Corrupts:
@@ -919,6 +917,10 @@ uninstall:
 	.ascii	"PAYL"
 	.long	0
 	.long	0
+	.long	_payload_align
+	.ascii	"COPY"
+	.long	_pprefix_lma
+	.long	_pprefix_filesz
 	.long	_max_align
 	.ascii	PACK_OR_COPY
 	.long	_text16_late_lma
@@ -932,3 +934,6 @@ uninstall:
 	.long	_textdata_lma
 	.long	_textdata_filesz
 	.long	_max_align
+
+	.weak	_payload_align
+	.equ	_payload_align, 1
diff --git a/roms/ipxe/src/arch/i386/prefix/lkrnprefix.S b/roms/ipxe/src/arch/i386/prefix/lkrnprefix.S
index f87ef85a9d5b59cd7a9af75306f4..690031f0d254859d8292e7c3353f 100644
--- a/roms/ipxe/src/arch/i386/prefix/lkrnprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/lkrnprefix.S
@@ -160,7 +160,7 @@ relocatable_kernel:
 pad2:
 	.byte	0, 0, 0
 cmdline_size:
-	.long	0
+	.long	0x7ff
 hardware_subarch:
 	.long	0
 hardware_subarch_data:
@@ -188,16 +188,61 @@ setup_code:
 	We're now at the beginning of the kernel proper.
  */
 run_ipxe:
-	/* Set up stack just below 0x7c00 */
+	/* Set up stack just below 0x7c00 and clear direction flag */
 	xorw	%ax, %ax
 	movw	%ax, %ss
 	movw	$0x7c00, %sp
+	cld
 
 	/* Retrieve command-line pointer */
-	movl	%es:cmd_line_ptr, %edx
+	movl	%ds:cmd_line_ptr, %edx
+	testl	%edx, %edx
+	jz	no_cmd_line
+
+	/* Set up %es:%di to point to command line */
+	movl	%edx, %edi
+	andl	$0xf, %edi
+	rorl	$4, %edx
+	movw	%dx, %es
+
+	/* Find length of command line */
+	pushw	%di
+	movw	$0xffff, %cx
+	repnz scasb
+	notw	%cx
+	popw	%si
+
+	/* Make space for command line on stack */
+	movw	%sp, %di
+	subw	%cx, %di
+	andw	$~0xf, %di
+	movw	%di, %sp
+
+	/* Copy command line to stack */
+	pushw	%ds
+	pushw	%es
+	popw	%ds
+	pushw	%ss
+	popw	%es
+	rep movsb
+	popw	%ds
+
+	/* Store new command-line pointer */
+	movzwl	%sp, %edx
+no_cmd_line:
+
+	/* Calculate maximum relocation address */
+	movl	ramdisk_image, %ebp
+	testl	%ebp, %ebp
+	jnz	1f
+	orl	$0xffffffff, %ebp /* Allow arbitrary relocation if no initrd */
+1:
 
 	/* Install iPXE */
-	call	install
+	call	alloc_basemem
+	xorl	%esi, %esi
+	xorl	%edi, %edi
+	call	install_prealloc
 
 	/* Set up real-mode stack */
 	movw	%bx, %ss
@@ -209,12 +254,20 @@ run_ipxe:
 	lret
 	.section ".text16", "awx", @progbits
 1:
+	/* Retrieve initrd pointer and size */
+	movl	ramdisk_image, %ebp
+	movl	ramdisk_size, %ecx
+
 	/* Set up %ds for access to .data16 */
 	movw	%bx, %ds
 
 	/* Store command-line pointer */
 	movl	%edx, cmdline_phys
 
+	/* Store initrd pointer and size */
+	movl	%ebp, initrd_phys
+	movl	%ecx, initrd_len
+
 	/* Run iPXE */
 	pushl	$main
 	pushw	%cs
diff --git a/roms/ipxe/src/arch/i386/prefix/mromprefix.S b/roms/ipxe/src/arch/i386/prefix/mromprefix.S
index 7bbe44c4ea1ceed59df97b1fb2b9..058663c4018f7edfcc25c58afd62 100644
--- a/roms/ipxe/src/arch/i386/prefix/mromprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/mromprefix.S
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  *
  */
 
@@ -30,6 +31,7 @@ FILE_LICENCE ( GPL2_OR_LATER )
 #define PCI_BAR_EXPROM			0x30
 
 #define ROMPREFIX_EXCLUDE_PAYLOAD 1
+#define ROMPREFIX_MORE_IMAGES 1
 #define _rom_start _mrom_start
 #include "romprefix.S"
 
@@ -46,8 +48,10 @@ FILE_LICENCE ( GPL2_OR_LATER )
  * Parameters:
  *   %ds:0000 : Prefix
  *   %esi : Buffer for copy of image source (or zero if no buffer available)
+ *   %ecx : Expected offset within buffer of first payload block
  * Returns:
  *   %esi : Valid image source address (buffered or unbuffered)
+ *   %ecx : Actual offset within buffer of first payload block
  *   CF set on error
  */
 	.section ".text16.early", "awx", @progbits
@@ -56,23 +60,25 @@ open_payload:
 	/* Preserve registers */
 	pushl	%eax
 	pushw	%bx
-	pushl	%ecx
 	pushl	%edx
 	pushl	%edi
 	pushw	%bp
+	pushw	%es
 	pushw	%ds
 
-	/* Retrieve bus:dev.fn and image source length from .prefix */
+	/* Retrieve bus:dev.fn from .prefix */
 	movw	init_pci_busdevfn, %bx
-	movl	image_source_len_dword, %ecx
 
 	/* Set up %ds for access to .text16.early */
 	pushw	%cs
 	popw	%ds
 
-	/* Store bus:dev.fn and image source length to .text16.early */
+	/* Set up %es for access to flat address space */
+	xorw	%ax, %ax
+	movw	%ax, %es
+
+	/* Store bus:dev.fn to .text16.early */
 	movw	%bx, payload_pci_busdevfn
-	movl	%ecx, rom_bar_copy_len_dword
 
 	/* Get expansion ROM BAR current value */
 	movw	$PCI_BAR_EXPROM, %di
@@ -149,6 +155,18 @@ find_mem_bar:
 	movw	$PCI_BAR_EXPROM, %di
 	call	pci_write_config_dword
 
+	/* Locate our ROM image */
+1:	addr32 es cmpw $0xaa55, (%eax)
+	stc
+	jne	99f
+	addr32 es cmpl $_build_id, build_id(%eax)
+	je	2f
+	addr32 es movzbl 2(%eax), %ecx
+	shll	$9, %ecx
+	addl	%ecx, %eax
+	jmp	1b
+2:
+
 	/* Copy payload to buffer, or set buffer address to BAR address */
 	testl	%esi, %esi
 	jz	1f
@@ -159,27 +177,32 @@ find_mem_bar:
 	 * properly support flat real mode, it will die horribly.)
 	 */
 	pushl	%esi
-	pushw	%es
 	movl	%esi, %edi
 	movl	%eax, %esi
-	movl	rom_bar_copy_len_dword, %ecx
-	xorw	%ax, %ax
-	movw	%ax, %es
+	addr32 es movzbl 2(%esi), %ecx
+	shll	$7, %ecx
+	addr32 es movzbl 2(%esi,%ecx,4), %edx
+	shll	$7, %edx
+	addl	%edx, %ecx
 	addr32 es rep movsl
-	popw	%es
 	popl	%esi
 	jmp	2f
 1:	/* We have no buffer; set %esi to the BAR address */
 	movl	%eax, %esi
 2:
 
+	/* Locate first payload block (after the dummy ROM header) */
+	addr32 es movzbl 2(%esi), %ecx
+	shll	$9, %ecx
+	addl	$_pprefix_skip, %ecx
+
 	clc
 	/* Restore registers and return */
 99:	popw	%ds
+	popw	%es
 	popw	%bp
 	popl	%edi
 	popl	%edx
-	popl	%ecx
 	popw	%bx
 	popl	%eax
 	lret
@@ -200,11 +223,6 @@ rom_bar_size:
 	.long	0
 	.size	rom_bar_size, . - rom_bar_size
 
-	.section ".text16.early.data", "aw", @progbits
-rom_bar_copy_len_dword:
-	.long	0
-	.size	rom_bar_copy_len_dword, . - rom_bar_copy_len_dword
-
 	.section ".text16.early.data", "aw", @progbits
 stolen_bar_register:
 	.word	0
@@ -419,16 +437,68 @@ pci_set_mem_access:
 	ret
 	.size	pci_set_mem_access, . - pci_set_mem_access
 
-/* Image source area length (in dwords)
+/* Payload prefix
  *
+ * We include a dummy ROM header to cover the "hidden" portion of the
+ * overall ROM image.
  */
-	.section ".prefix", "ax", @progbits
-image_source_len_dword:
+	.globl	_payload_align
+	.equ	_payload_align, 512
+	.section ".pprefix", "ax", @progbits
+	.org	0x00
+mromheader:
+	.word	0xaa55			/* BIOS extension signature */
+mromheader_size: .byte 0		/* Size in 512-byte blocks */
+	.org	0x18
+	.word	mpciheader
+	.org	0x1a
+	.word	0
+	.size	mromheader, . - mromheader
+
+	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
+	.ascii	"APPB"
+	.long	mromheader_size
+	.long	512
 	.long	0
-	.size	image_source_len_dword, . - image_source_len_dword
+	.previous
+
+mpciheader:
+	.ascii	"PCIR"			/* Signature */
+	.word	pci_vendor_id		/* Vendor identification */
+	.word	pci_device_id		/* Device identification */
+	.word	0x0000			/* Device list pointer */
+	.word	mpciheader_len		/* PCI data structure length */
+	.byte	0x03			/* PCI data structure revision */
+	.byte	0x02, 0x00, 0x00	/* Class code */
+mpciheader_image_length:
+	.word	0			/* Image length */
+	.word	0x0001			/* Revision level */
+	.byte	0xff			/* Code type */
+	.byte	0x80			/* Last image indicator */
+mpciheader_runtime_length:
+	.word	0			/* Maximum run-time image length */
+	.word	0x0000			/* Configuration utility code header */
+	.word	0x0000			/* DMTF CLP entry point */
+	.equ	mpciheader_len, . - mpciheader
+	.size	mpciheader, . - mpciheader
+
+	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
+	.ascii	"APPW"
+	.long	mpciheader_image_length
+	.long	512
+	.long	0
+	.ascii	"APPW"
+	.long	mpciheader_runtime_length
+	.long	512
+	.long	0
+	.previous
+
+/* Fix up additional image source size
+ *
+ */
 	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
-	.ascii	"ADDL"
-	.long	image_source_len_dword
-	.long	4
+	.ascii	"ADPW"
+	.long	extra_size
+	.long	512
 	.long	0
 	.previous
diff --git a/roms/ipxe/src/arch/i386/prefix/nbiprefix.S b/roms/ipxe/src/arch/i386/prefix/nbiprefix.S
index 20d224d69b724aa00bc5f14260a3..06e7df5b747bc791e57ea3608cfb 100644
--- a/roms/ipxe/src/arch/i386/prefix/nbiprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/nbiprefix.S
@@ -54,6 +54,10 @@ _nbi_start:
 	/* Install iPXE */
 	call	install
 
+	/* Set up real-mode stack */
+	movw	%bx, %ss
+	movw	$_estack16, %sp
+
 	/* Jump to .text16 segment */
 	pushw	%ax
 	pushw	$1f
diff --git a/roms/ipxe/src/arch/i386/prefix/pxeprefix.S b/roms/ipxe/src/arch/i386/prefix/pxeprefix.S
index b7468cdf05b50a10a7600d1e5f97..05db9894cc00b57f9c9b5d51747f 100644
--- a/roms/ipxe/src/arch/i386/prefix/pxeprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/pxeprefix.S
@@ -5,6 +5,7 @@ FILE_LICENCE ( GPL2_OR_LATER )
 #define PXENV_UNDI_GET_IFACE_INFO	0x0013
 #define	PXENV_STOP_UNDI			0x0015
 #define PXENV_UNLOAD_STACK		0x0070
+#define PXENV_FILE_CMDLINE		0x00e8
 
 #define PXE_HACK_EB54			0x0001
 
@@ -19,6 +20,8 @@ FILE_LICENCE ( GPL2_OR_LATER )
 #define EB_MAGIC_1 ( 'E' + ( 't' << 8 ) + ( 'h' << 16 ) + ( 'e' << 24 ) )
 #define EB_MAGIC_2 ( 'r' + ( 'b' << 8 ) + ( 'o' << 16 ) + ( 'o' << 24 ) )
 
+#define PREFIX_STACK_SIZE 2048
+
 /*****************************************************************************
  * Entry point:	set operating context, print welcome message
  *****************************************************************************
@@ -46,10 +49,11 @@ _pxe_start:
 	movw	%ax, %ds
 	movw	$0x40, %ax		/* BIOS data segment access */
 	movw	%ax, %fs
-	/* Set up stack just below 0x7c00 */
-	xorw	%ax, %ax
+	/* Set up temporary stack immediately after the iPXE image */
+	movw	%cs, %ax
+	addw	image_size_pgh, %ax
 	movw	%ax, %ss
-	movl	$0x7c00, %esp
+	movl	$PREFIX_STACK_SIZE, %esp
 	/* Clear direction flag, for the sake of sanity */
 	cld
 	/* Print welcome message */
@@ -60,6 +64,18 @@ _pxe_start:
 10:	.asciz	"PXE->EB:"
 	.previous
 
+	/* Image size (for stack placement calculation) */
+	.section ".prefix.data", "aw", @progbits
+image_size_pgh:
+	.word	0
+	.previous
+	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
+	.ascii	"ADDW"
+	.long	image_size_pgh
+	.long	16
+	.long	0
+	.previous
+
 /*****************************************************************************
  * Find us a usable !PXE or PXENV+ entry point
  *****************************************************************************
@@ -366,6 +382,35 @@ get_iface_type:
 99:	movb	$0x0a, %al
 	call	print_character
 
+
+/*****************************************************************************
+ * Check for a command line
+ *****************************************************************************
+ */
+get_cmdline:
+	/* Issue PXENV_FILE_CMDLINE */
+	xorl	%esi, %esi
+	movw	%ss, %si
+	movw	%si, ( pxe_parameter_structure + 0x06 )
+	movw	$PREFIX_STACK_SIZE, ( pxe_parameter_structure + 0x04 )
+	movw	$0xffff, ( pxe_parameter_structure + 0x02 )
+	movw	$PXENV_FILE_CMDLINE, %bx
+	call	pxe_call
+	jc	99f  /* Suppress errors; this is an iPXE extension API call */
+	/* Check for non-NULL command line */
+	movw	( pxe_parameter_structure + 0x02 ), %ax
+	testw	%ax, %ax
+	jz	99f
+	/* Record command line */
+	shll	$4, %esi
+	addl	$PREFIX_STACK_SIZE, %esi
+	movl	%esi, pxe_cmdline
+99:
+	.section ".prefix.data", "aw", @progbits
+pxe_cmdline:
+	.long	0
+	.previous
+
 /*****************************************************************************
  * Leave NIC in a safe state
  *****************************************************************************
@@ -713,6 +758,9 @@ run_ipxe:
 	movw	pxe_ss,	%di
 	movl	pxe_esp, %ebp
 
+	/* Retrieve PXE command line, if any */
+	movl	pxe_cmdline, %esi
+
 	/* Jump to .text16 segment with %ds pointing to .data16 */
 	movw	%bx, %ds
 	pushw	%ax
@@ -721,11 +769,10 @@ run_ipxe:
 	.section ".text16", "ax", @progbits
 1:
 	/* Update the exit hook */
-	movw	%cs,pxe_exit_hook+2
-	push	%ax
-	mov	$2f,%ax
-	mov	%ax,pxe_exit_hook
-	pop	%ax
+	movw	%cs, ( pxe_exit_hook + 2 )
+
+	/* Store command-line pointer */
+	movl	%esi, cmdline_phys
 
 	/* Run main program */
 	pushl	$main
@@ -743,7 +790,14 @@ run_ipxe:
 	/* Jump to hook if applicable */
 	ljmpw	*pxe_exit_hook
 
-2:	/* Check PXE stack magic */
+	.section ".data16", "aw", @progbits
+	.globl	pxe_exit_hook
+pxe_exit_hook:
+	.word	exit_ipxe, 0
+	.previous
+
+exit_ipxe:
+	/* Check PXE stack magic */
 	popl	%eax
 	cmpl	$STACK_MAGIC, %eax
 	jne	1f
diff --git a/roms/ipxe/src/arch/i386/prefix/romprefix.S b/roms/ipxe/src/arch/i386/prefix/romprefix.S
index dd602ddb7108fb6afa0805a31220..091673d3c885e9301b0ab47baa43 100644
--- a/roms/ipxe/src/arch/i386/prefix/romprefix.S
+++ b/roms/ipxe/src/arch/i386/prefix/romprefix.S
@@ -23,6 +23,7 @@ FILE_LICENCE ( GPL2_OR_LATER )
 	( PMM_HANDLE_BASE | 0x00001000 )
 #define PMM_HANDLE_BASE_DECOMPRESS_TO \
 	( PMM_HANDLE_BASE | 0x00002000 )
+#define PCI_FUNC_MASK 0x07
 
 /* ROM banner timeout.  Based on the configurable BANNER_TIMEOUT in
  * config.h, but converted to a number of (18Hz) timer ticks, and
@@ -39,6 +40,14 @@ FILE_LICENCE ( GPL2_OR_LATER )
 #else
 #define	ZINFO_TYPE_ADxB "ADDB"
 #define	ZINFO_TYPE_ADxW "ADDW"
+#endif
+
+/* Allow ROM to be marked as containing multiple images
+ */
+#if ROMPREFIX_MORE_IMAGES
+#define INDICATOR 0x00
+#else
+#define INDICATOR 0x80
 #endif
 
 	.text
@@ -55,6 +64,8 @@ romheader_size:	.byte 0			/* Size in 512-byte blocks */
 	jmp	init			/* Initialisation vector */
 checksum:
 	.byte	0
+	.org	0x10
+	.word	ipxeheader
 	.org	0x16
 	.word	undiheader
 	.org	0x18
@@ -70,9 +81,6 @@ checksum:
 	.long	0
 	.previous
 
-build_id:
-	.long	_build_id		/* Randomly-generated build ID */
-
 pciheader:
 	.ascii	"PCIR"			/* Signature */
 	.word	pci_vendor_id		/* Vendor identification */ 
@@ -85,7 +93,7 @@ pciheader_image_length:
 	.word	0			/* Image length */
 	.word	0x0001			/* Revision level */
 	.byte	0x00			/* Code type */
-	.byte	0x80			/* Last image indicator */
+	.byte	INDICATOR		/* Last image indicator */
 pciheader_runtime_length:
 	.word	0			/* Maximum run-time image length */
 	.word	0x0000			/* Configuration utility code header */
@@ -104,6 +112,11 @@ pciheader_runtime_length:
 	.long	0
 	.previous
 
+	/* PnP doesn't require any particular alignment, but IBM
+	 * BIOSes will scan on 16-byte boundaries rather than using
+	 * the offset stored at 0x1a
+	 */
+	.align	16
 pnpheader:
 	.ascii	"$PnP"			/* Signature */
 	.byte	0x01			/* Structure revision */
@@ -162,6 +175,25 @@ undiheader:
 	.equ undiheader_len, . - undiheader
 	.size undiheader, . - undiheader
 
+ipxeheader:
+	.ascii	"iPXE"			/* Signature */
+	.byte	ipxeheader_len		/* Length of structure */
+	.byte	0			/* Checksum */
+shrunk_rom_size:
+	.byte	0			/* Shrunk size (in 512-byte blocks) */
+	.byte	0			/* Reserved */
+build_id:
+	.long	_build_id		/* Randomly-generated build ID */
+	.equ ipxeheader_len, . - ipxeheader
+	.size ipxeheader, . - ipxeheader
+
+	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
+	.ascii	"ADHB"
+	.long	shrunk_rom_size
+	.long	512
+	.long	0
+	.previous
+
 /* Initialisation (called once during POST)
  *
  * Determine whether or not this is a PnP system via a signature
@@ -286,6 +318,7 @@ pnp_scan:
 	call	print_message
 	jmp	pnp_done
 no_pnp:	/* Not PnP-compliant - hook INT 19 */
+#ifdef NONPNP_HOOK_INT19
 	movw	$init_message_int19, %si
 	xorw	%di, %di
 	call	print_message
@@ -296,6 +329,7 @@ no_pnp:	/* Not PnP-compliant - hook INT 19 */
 	pushw	%gs /* %gs contains runtime %cs */
 	pushw	$int19_entry
 	popl	%es:( 0x19 * 4 )
+#endif /* NONPNP_HOOK_INT19 */
 pnp_done:
 
 	/* Check for PMM */
@@ -319,14 +353,19 @@ pmm_scan:
 	call	print_message
 	/* We have PMM and so a 1kB stack: preserve whole registers */
 	pushal
-	/* Allocate image source PMM block */
-	movzwl	image_source_size, %ecx
+	/* Allocate image source PMM block.  Round up the size to the
+	 * nearest 4kB (8 512-byte sectors) to work around AMI BIOS bugs.
+	 */
+	movzbl	romheader_size, %ecx
+	addw	extra_size, %cx
+	addw	$0x0007, %cx	/* Round up to multiple of 8 512-byte sectors */
+	andw	$0xfff8, %cx
 	shll	$5, %ecx
 	movl	$PMM_HANDLE_BASE_IMAGE_SOURCE, %ebx
 	movw	$get_pmm_image_source, %bp
 	call	get_pmm
 	movl	%esi, image_source
-	jc	1f
+	jz	1f
 	/* Copy ROM to image source PMM block */
 	pushw	%es
 	xorw	%ax, %ax
@@ -334,8 +373,8 @@ pmm_scan:
 	movl	%esi, %edi
 	xorl	%esi, %esi
 	movzbl	romheader_size, %ecx
-	shll	$9, %ecx
-	addr32 rep movsb	/* PMM presence implies flat real mode */
+	shll	$7, %ecx
+	addr32 rep movsl	/* PMM presence implies flat real mode */
 	popw	%es
 	/* Shrink ROM */
 	movb	shrunk_rom_size, %al
@@ -384,6 +423,9 @@ no_pmm:
 	xorw	%di, %di
 	cs rep	movsb
 
+	/* Skip prompt if this is not the first PCI function */
+	testb	$PCI_FUNC_MASK, init_pci_busdevfn
+	jnz	no_shell
 	/* Prompt for POST-time shell */
 	movw	$init_message_prompt, %si
 	xorw	%di, %di
@@ -402,15 +444,19 @@ no_pmm:
 	movw	$init_message_done, %si
 	call	print_message
 	popf
-	jnz	2f
+	jnz	no_shell
 	/* Ctrl-B was pressed: invoke iPXE.  The keypress will be
 	 * picked up by the initial shell prompt, and we will drop
 	 * into a shell.
 	 */
-	stc			/* Inhibit relocation */
+	xorl	%ebp, %ebp	/* Inhibit use of INT 15,e820 and INT 15,e801 */
 	pushw	%cs
 	call	exec
-2:
+no_shell:
+	movb	$( '\n' ), %al
+	xorw	%di, %di
+	call	print_character
+
 	/* Restore registers */
 	popw	%gs
 	popw	%fs
@@ -432,13 +478,13 @@ no_pmm:
  *  %es:0000 : PMM structure
  * Returns:
  *  %ebx : PMM handle
- *  %esi : allocated block address, or zero (with CF set) if allocation failed
+ *  %esi : allocated block address, or zero (with ZF set) if allocation failed
  */
 get_pmm:
 	/* Preserve registers */
 	pushl	%eax
 	pushw	%di
-	movw	$' ', %di
+	movw	$( ' ' ), %di
 get_pmm_find:
 	/* Try to find existing block */
 	pushl	%ebx		/* PMM handle */
@@ -448,7 +494,10 @@ get_pmm_find:
 	pushw	%dx
 	pushw	%ax
 	popl	%esi
-	testl	%esi, %esi
+	/* Treat 0xffffffff (not supported) as 0x00000000 (not found) */
+	incl	%esi
+	jz	get_pmm_allocate
+	decl	%esi
 	jz	get_pmm_allocate
 	/* Block found - check acceptability */
 	call	*%bp
@@ -467,20 +516,21 @@ get_pmm_allocate:
 	pushw	%dx
 	pushw	%ax
 	popl	%esi
-	movw	$'+', %di	/* Indicate allocation attempt */
-	testl	%esi, %esi
-	jnz	get_pmm_done
-	stc
+	movw	$( '+' ), %di	/* Indicate allocation attempt */
 get_pmm_done:
 	/* Print block address */
-	pushfw
 	movw	%di, %ax
 	xorw	%di, %di
 	call	print_character
 	movl	%esi, %eax
 	call	print_hex_dword
-	popfw
-	/* Restore registers and return */
+	/* Treat 0xffffffff (not supported) as 0x00000000 (allocation
+	 * failed), and set ZF to indicate a zero result.
+	 */
+	incl	%esi
+	jz	1f
+	decl	%esi
+1:	/* Restore registers and return */
 	popw	%di
 	popl	%eax
 	ret
@@ -553,7 +603,7 @@ init_message_done:
  *
  */
 init_pci_busdevfn:
-	.word	0xffff
+	.word	0
 	.size	init_pci_busdevfn, . - init_pci_busdevfn
 
 /* Image source area
@@ -566,31 +616,12 @@ image_source:
 	.long	0
 	.size	image_source, . - image_source
 
-/* Image source size (in 512-byte sectors)
+/* Additional image source size (in 512-byte sectors)
  *
  */
-image_source_size:
+extra_size:
 	.word	0
-	.size	image_source_size, . - image_source_size
-	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
-	.ascii	"ADDW"
-	.long	image_source_size
-	.long	512
-	.long	0
-	.previous
-
-/* Shrunk ROM size (in 512-byte sectors)
- *
- */
-shrunk_rom_size:
-	.byte	0
-	.size	shrunk_rom_size, . - shrunk_rom_size
-	.section ".zinfo.fixup", "a", @progbits	/* Compressor fixups */
-	.ascii	"ADHB"
-	.long	shrunk_rom_size
-	.long	512
-	.long	0
-	.previous
+	.size	extra_size, . - extra_size
 
 /* Temporary decompression area
  *
@@ -607,7 +638,7 @@ decompress_to:
  * Called by the PnP BIOS when it wants to boot us.
  */
 bev_entry:
-	clc			/* Allow relocation */
+	orl	$0xffffffff, %ebp	/* Allow arbitrary relocation */
 	pushw	%cs
 	call	exec
 	lret
@@ -642,7 +673,7 @@ int19_entry:
 	/* Leave keypress in buffer and start iPXE.  The keypress will
 	 * cause the usual initial Ctrl-B prompt to be skipped.
 	 */
-	clc			/* Allow relocation */
+	orl	$0xffffffff, %ebp	/* Allow arbitrary relocation */
 	pushw	%cs
 	call	exec
 1:	/* Try to call original INT 19 vector */
@@ -674,9 +705,6 @@ exec:	/* Set %ds = %cs */
 	pushw	%cs
 	popw	%ds
 
-	/* Preserve state of CF */
-	lahf
-
 	/* Print message as soon as possible */
 	movw	$prodstr, %si
 	xorw	%di, %di
@@ -686,8 +714,8 @@ exec:	/* Set %ds = %cs */
 
 	/* Store magic word on BIOS stack and remember BIOS %ss:sp */
 	pushl	$STACK_MAGIC
-	movw	%ss, %dx
-	movw	%sp, %bp
+	movw	%ss, %cx
+	movw	%sp, %dx
 
 	/* Obtain a reasonably-sized temporary stack */
 	xorw	%bx, %bx
@@ -695,10 +723,7 @@ exec:	/* Set %ds = %cs */
 	movw	$0x7c00, %sp
 
 	/* Install iPXE */
-	sahf
-	pushfw
 	call	alloc_basemem
-	popfw
 	movl	image_source, %esi
 	movl	decompress_to, %edi
 	call	install_prealloc
@@ -721,14 +746,14 @@ exec:	/* Set %ds = %cs */
 	pushl	$main
 	pushw	%cs
 	call	prot_call
-	popl	%ecx /* discard */
+	popl	%eax /* discard */
 
 	/* Uninstall iPXE */
 	call	uninstall
 
 	/* Restore BIOS stack */
-	movw	%dx, %ss
-	movw	%bp, %sp
+	movw	%cx, %ss
+	movw	%dx, %sp
 
 	/* Check magic word on BIOS stack */
 	popl	%eax
